/*
 * Written by Sinan & Sami. Copyright 1993, TUBITAK Software
 * Research & Development Center, Ankara, TURKIYE
 * This program is freely distributable without licensing fees and
 * is provided without guarantee or warrantee expressed or implied.
 *
 */

#include <Xm/MainW.h>
#include <Xm/DrawingA.h>
#include <Xm/PushBG.h>
#include <Xm/PushB.h>
#include <Xm/RowColumn.h>
#include <Xm/Frame.h>
#include <Xm/ScrolledW.h>

#include "type.h"

Pixmap pixmap; /* used to redraw the DrawingArea */

 extern vertex **tree;
main(argc, argv)
int argc;
char *argv[];
{
    Widget toplevel, drawing_a, pb,frame;
    XtAppContext app;
    XGCValues gcv;
    GC gc;
    Display *display;
    int i;
    Widget main_w;
    XtActionsRec actions;
    Widget button;

       String translations = "";/* for the DrawingArea widget */
        /* ManagerGadget* functions are necessary for DrawingArea widgets
         * that steal away button events from the normal translation tables.
         */
/*        "<Btn1Down>: draw(down) ManagerGadgetArm()\n\
         <Btn1Up>: draw(up) ManagerGadgetActivate()\n\
         <Btn1Motion>: draw(motion) ManagerGadgetButtonMotion()";
*/
    void drawing_area_callback();

    toplevel = XtVaAppInitialize(&app, "XMdag", NULL, 0, 
        &argc, argv, NULL,
        XmNwidth,  900,
        XmNheight, 500,
        NULL);
    main_w = XtVaCreateManagedWidget("main_w",
        xmMainWindowWidgetClass, toplevel,
        XmNscrollingPolicy, XmAUTOMATIC,
        NULL);

    /* Create a DrawingArea widget.  Make it 5 inches wide by 6 inches tall.
     * Don't let it resize so the Clear Button doesn't force a resize.
     */
    drawing_a = XtVaCreateManagedWidget("drawing_a",
        xmDrawingAreaWidgetClass, main_w,
        XmNtranslations, XtParseTranslationTable(translations),
        XmNwidth,        1900, /* 5 inches */
        XmNheight,       1900, /* 6 inches */
        XmNresizePolicy, XmNONE,  /* remain this a fixed size */
        NULL);
    /* When scrolled, the drawing area will get expose events */

    /* add callback for all mouse and keyboard input events */
    XtAddCallback(drawing_a, XmNexposeCallback, drawing_area_callback, NULL);
/*
     * and therefore need a graphics context.  Create a GC and attach
     * to the DrawingArea's XmNuserData to avoid having to make global
     * variable. (Avoiding globals is a good design principle to follow.)
     */
    gcv.foreground = BlackPixelOfScreen(XtScreen(drawing_a));
    gc = XCreateGC(XtDisplay(drawing_a),
        RootWindowOfScreen(XtScreen(drawing_a)), GCForeground, &gcv);
    XtVaSetValues(drawing_a, XmNuserData, gc, NULL);
/*
    pixmap = XCreatePixmap(XtDisplay(drawing_a),
        RootWindowOfScreen(XtScreen(drawing_a)), 400, 400,
        DefaultDepthOfScreen(XtScreen(drawing_a)));

*/ 

    median(argc,argv);
    position();
    for(i=0;tree[i][0].id;i++)
    {
      int j=0,k;
      while(tree[i][j].id)
      {
         if(strcmp(tree[i][j].name,"du"))
         {
         int x,y,x1,y1;
         x=tree[i][j].x;
         y=tree[i][j].y;
         frame = XtVaCreateManagedWidget("frame1",
            xmFrameWidgetClass, drawing_a,
            XmNshadowType,      XmSHADOW_OUT,
            XmNx,     tree[i][j].x,
            XmNy,   tree[i][j].y,
            NULL);
            tree[i][j].name[4]=0;
            button = XtVaCreateManagedWidget(tree[i][j].name,
            xmPushButtonGadgetClass , frame,NULL);
          }
            j++;
         
       }
    }
 /*   XtManageChild(drawing_a);
*/
    XtRealizeWidget(toplevel);

    XtAppMainLoop(app);

}

void coord(vertex *a, unsigned id, int * x, int *y)
{
   int i=0;
   while(a[i].id != id) 
        i++;
   *x=a[i].x;
   *y=a[i].y;
   if(!strcmp(a[i].name,"du"))
      *x -=15;
}



/* Callback routine for DrawingArea's input callbacks and the
 * PushButton's activate callback.  Determine which it is by
 * testing the cbs->reason field.
 */
void
drawing_area_callback(widget, data, cbs)
Widget widget;
XtPointer data;
XmDrawingAreaCallbackStruct *cbs;
{
    XEvent *event = cbs->event;
    unsigned i;
    Widget frame;

    GC gc;
    XtVaGetValues(widget, XmNuserData, &gc, NULL);
    for(i=0;tree[i][0].id;i++)
    {
      int j=0,k;

      while(tree[i][j].id)
      {
         int x,y,x1,y1;
         x=tree[i][j].x;
	 y=tree[i][j].y; 
         for(k=0;k<tree[i][j].no_of_child;k++)
	 {
	   coord(tree[i+1],tree[i][j].child[k],&x1,&y1);
           if(!strcmp(tree[i][j].name,"du"))
           {
   		x-=15;
		y-=30;
	   }
	   XDrawLine(event->xany.display, cbs->window, gc,
                    x+15,y+30,x1+15,y1);
	 }

         j++;

      }
    }
 
/*  if (cbs->reason == XmCR_ACTIVATE)
        XClearWindow(event->xany.display, XtWindow(XtParent(widget)));
*/
}
