/*
 * Written by Sinan & Sami.  Copyright 1993, TUBITAK Software
 * Research & Development Center, Ankara, TURKIYE
 * This program is freely distributable without licensing fees and
 * is provided without guarantee or warrantee expressed or implied.
 *
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include "type.h"

#define VERTSIZE 100
extern vertex **tree;
int i,j;

void coord2(vertex *a, unsigned id, int * x, int *y)
{
   int i=0;
   while(a[i].id != id)
        i++;
   *x=a[i].x;
   *y=a[i].y;
}


void  coorAvg(vertex *a,unsigned t,int *x)
{
      int i,t1=0;
      *x=0;
      for(i=0;i<levelLength(a);i++)
	if(intchr(a[i].child,t,a[i].no_of_child))
	 (*x)+=a[i].x,t1++;
      (*x)/=t1;
}



int posCompare(const void *a, const void *b)
{
   unsigned *x=(unsigned *)a;
   unsigned *y=(unsigned *)b;

   unsigned conX=tree[i][*x].no_of_parent;
   unsigned conY=tree[i][*y].no_of_parent;
   if(!strcmp(tree[i][*x].name,"du") && !strcmp(tree[i][*y].name,"du"))
      return(0);
   if(!strcmp(tree[i][*x].name,"du"))
      return(-1);

   if(conY==conX)
      return(0);
   if(conY>conX)
      return(1);
   return(-1);
}
int posCompare2(const void *a, const void *b)
{
   unsigned *x=(unsigned *)a;
   unsigned *y=(unsigned *)b;

   unsigned conX=tree[i][*x].no_of_parent;
   unsigned conY=tree[i][*y].no_of_parent;
   if(!strcmp(tree[i][*x].name,"du") && !strcmp(tree[i][*y].name,"du"))
      return(0);
   if(!strcmp(tree[i][*x].name,"du"))
      return(1);

   if(conY==conX)
      return(0);
   if(conY>conX)
      return(-1);
   return(1);
}

void position()
{
    int x,y,t1;
    unsigned t,dummy1;
    unsigned * orders;
    for(i=0;tree[i][0].id;i++,j=0)
      while(tree[i][j].id)
      {
	 tree[i][j].y=i*100+15;
	 tree[i][j].x=(j+1)*600/(levelLength(tree[i])+1)+100;
	 j++;
      }
    for(i=1;tree[i][0].id;i++)
    {
      j=0;
      t1=levelLength(tree[i]);
      orders=(unsigned *)malloc(sizeof(unsigned)*t1);
      for(j=0;j<t1;j++)
	orders[j]=j;
      qsort(orders,t1,sizeof(unsigned),posCompare);
      for(j=0;j<t1;j++)
      {
	 if(strcmp(tree[i][orders[j]].name,"du"))
	     coorAvg(tree[i-1],tree[i][orders[j]].id,&x);
	 else
	     coord2(tree[i-1],tree[i][orders[j]].parent[0],&x,&y);

	 tree[i][orders[j]].x=x;
         dummy1=orders[j]+1;
	 if(
	    (orders[j]!=t1-1)
	    &&
            (posCompare2((void *) &dummy1,(void *)(orders+j)) >= 0)

/*            ((intchr(orders,orders[j]+1,t1)-orders) <= (intchr(orders,orders[j],t1)-orders))

	    (tree[i][orders[j]+1].no_of_parent > tree[i][orders[j]].no_of_parent )
(*/
	    &&
	    (tree[i][orders[j]+1].x < x+VERTSIZE)
	   )
	   {
	       tree[i][orders[j]].x=tree[i][orders[j]+1].x-VERTSIZE;
	   }
         dummy1=orders[j]-1;
	 if(
	      (orders[j])
	      &&
              (posCompare2((void *) &dummy1,(void *) (orders+j)) >= 0)
              &&
/*
              ((intchr(orders,orders[j]-1,t1)-orders) <= (intchr(orders,orders[j],t1)-orders))
	      &&

	      (tree[i][orders[j]-1].no_of_parent >= tree[i][orders[j]].no_of_parent )
*/
	      (tree[i][orders[j]-1].x >x-VERTSIZE)
	     )
	     {
		    tree[i][orders[j]].x=tree[i][orders[j]-1].x+VERTSIZE;
	     }
          dummy1=orders[j]+1;
	 if(
	    (orders[j])
	    &&
	    (orders[j]!=t1-1)
	    &&
            (posCompare2((void *) &dummy1,(void *)(orders+j)) >= 0)
/*	    (tree[i][orders[j]+1].no_of_parent >= tree[i][orders[j]].no_of_parent )*/
	    &&
	    (tree[i][orders[j]+1].x < x+VERTSIZE)
	   )
	   {
	       tree[i][orders[j]].x=(tree[i][orders[j]+1].x+
				     tree[i][orders[j]-1].x)/2;
	   }

      }
      free(orders);
    }

}
